#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
# !+-------------------------------------------------------------------------
#    Name:  dbamon_helper.pl
#
# Purpose:  From STAR icon on DBAmon instance summary
#
#   Specs: 
#
#  Author:  Bill Border
#
# !*-------------------------------------------------------------------------
$| = 1;
chop($P = `basename $0`);
use DBI;
require "cgi_handlers.pl";
system("env > /tmp/www_env.txt"); 

# Read WWW_Check:
chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
if ($font =~ /%/)
{
  $font =~ s/%/ /g;
  $font = "'$font'";
}

$days = 15;
$fs = "<font size=2 face=$font>";
$font = "arial" if ! $font;

push(@INC,"/opt/dbamon/lib");
require "subs.pl";
require "subsDB.pl";
require "subsWWW.pl";


# Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

$tmpemail = "/tmp/${P}_${$}_tmpemail.txt";

chop($date     = `date`);
chop($host     = `hostname`);
$hostname = $host; 
chop($fqhostname = `nslookup $host | grep Name: | awk '{ print \$2 }'`) if -e '/etc/resolv.conf';
$http_host = $ENV{'HTTP_HOST'}; 

## Save Company name
#chop($compwork = `nslookup $host | grep Name: | awk '{ print \$2 }'`);
#@words = split(/\./,$compwork);
#$nexttolast = $#words - 1;
##$company = $words[$nexttolast];

$database = "dbamon";

# See if DBAmon is configured to use Oracle
chop($use_oracle  = `grep Use_Oracle:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
if ($use_oracle eq "Y" && $ORACLE_SID ne "" && $ORACLE_HOME ne "")
{
  $ENV{'ORACLE_SID'}  = $ORACLE_SID;
  $ENV{'ORACLE_HOME'} = $ORACLE_HOME;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $ORACLE_SID;
  $dbms = "oracle";
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  $msgflag = $_[1];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  if (! $msgflag)
  {
    print "<br><font size=2>$date ${P} | <b>$msgmsg</b></font>\n";
  }
  else
  {
    print "<br><font size=2>$date ${P} | <font color=darkred><b>$msgmsg</b></font></font></b>\n";
  }
}

#------------------------------------------------------------------------------
sub timeToText
#------------------------------------------------------------------------------
{
  $zz_ts = $_[0];
  ($sec,$min,$hour,$mday,$mon,$year) = localtime($zz_ts);
  $year += 1900;
  $mon += 1;

  # Pad with 0's
  $yy = sprintf("%04d",$year);
  $mm = sprintf("%02d",$mon);
  $dd = sprintf("%02d",$mday);
  $hh = sprintf("%02d",$hour);
  $mi = sprintf("%02d",$min);
  $ss = sprintf("%02d",$sec);

  $date = "$yy/$mm/$dd-$hh:$mi:$ss";
  return $date;
}

#-----------------------------------------------------------------------------
sub displayError 
#-----------------------------------------------------------------------------
{
   local($errorMsg) = @_;

   print "Content-type: text/html\n\n";
   print "<body><font face=$font><hr>";

   &msg("The following DB error occured:");
   print "<b>$errorMsg</b>";
   $sqlerror = $DBI::errstr;
   print "<br>SQL statement: $statement";
   print "<br>SQL error: $sqlerror <hr>";

   &PrintLinks;

   print "</body>";
   print "</html>";

   exit(1);
}

#-----------------------------------------------------------------------------
sub connectDBOld
#-----------------------------------------------------------------------------
{
  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
         &displayError('Failed_on_DB_connect_in_updateDb');
}

#-----------------------------------------------------------------------------
sub processSelection
#-----------------------------------------------------------------------------
{
  $s_time = time;

  if ($dbamon_repos eq "O") 
  {
    $sql  = "
      select 
	text
      from 
	dbamon.events 
      where 
	instance = '$instance' and ts = to_date('${event_ts}','YYYY/MM/DD-HH24:MI:SS') 
    ";
  }
  else #---- MSSQL
  {
    $re_event_ts = $event_ts;
    $re_event_ts =~ s/\-/ /g;
    $re_event_ts =~ s/\//\-/g;
    &msg("re_event_ts=$re_event_ts"); 
    $sql  = "
      select 
	text
      from 
	dbamon.events 
      where 
	instance = '$instance' 
        --and ts = to_date('${event_ts}','YYYY/MM/DD-HH24:MI:SS') 
        and ts = '${re_event_ts}' 
    ";
  }
  &msg("sql=$sql");

  $sth = $dbh->prepare($sql) || &displayError('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &displayError('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed = $e_time - $s_time;

  &msg("Query elapsed time: $elapsed seconds");

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $text    = $Data[0];
    &msg("text=$text"); 
  }

  if ($selectcount == 0) 
  { 
    &msg("Row not found"); 
  }
  &msg("Rows Selected: $selectcount");

  #---- Get STAR contacts 
  &getCMDBInfo;

  ## &msg("TEST MODE - Sending all email to BB"); 
  ## $email_recip = "bill.border\@hp.com"; 

  #---- Send email
  &sendEmail; 

  #---- Inhibit this instance for 4 hours
  &inhibit4Hours;
}

#-----------------------------------------------------------------------------
sub inhibit4Hours
#-----------------------------------------------------------------------------
{
  $inh_instance = "${in_hostname}_${in_instance}"; 
  $save_date = $date;

  if ($in_instance eq "MSSQL")
  {
    $inh_file = "/opt/dbamon/adm/inhibit/${in_hostname}_"; 
  }
  else
  {
    $inh_file = "/opt/dbamon/adm/inhibit/$inh_instance"; 
  }

  &msg("Inhibiting $inh_instance for 4 hours - inh_file=$inh_file"); 

  $basetime = time;
  $inh_hash{0} = &timeToText($basetime + (0*2600)); 
  $inh_hash{1} = &timeToText($basetime + (1*3600)); 
  $inh_hash{2} = &timeToText($basetime + (2*3600)); 
  $inh_hash{3} = &timeToText($basetime + (3*3600)); 

  foreach (sort keys %inh_hash)
  {
    $key = $_; 
    $datepart = substr($inh_hash{$key},0,10); 
    $timepart = substr($inh_hash{$key},11,2); 
    $inh_entry = "Date=$datepart Hour=$timepart   #---- Created by $P $save_date"; 
    &msg("  Writing line to $inh_file: $inh_entry"); 
    system("echo '$inh_entry' >> $inh_file"); 
  }
  &msg("This DB instance has been inhibited for 4 Hours",1); 
}

#-----------------------------------------------------------------------------
sub getCMDBInfo
#-----------------------------------------------------------------------------
{
  &msg("Obtaining email addresses from CMDB"); 
  foreach $line (`/opt/dbamon/bin/dbamon_www_email_tofile.pl $in_hostname $in_domain $in_instance`)
  {
    if ($line =~ /^ADDRESSES:/)
    {
      @words = split(/,/,$line);
      chop($email_recip = substr($line,11)); 
      last;
    }
  }
  &msg("Resulting email_recip=$email_recip"); 
}

#-----------------------------------------------------------------------------
sub sendEmail
#-----------------------------------------------------------------------------
{
  &msg("Sending incident notification email to $email_recip",1); 
  $emailhdr = "From: DBCC <noreply\@dba.it.thecompany.com>
Subject: DBCC DBAmon Incident Notification for DB Instance: $instance (Sent $date)
To: $email_recip 
Content-type: text/html
  ";

  $emailout = "
<body bgcolor=white> <font face='Trebuchet MS' size=2> 
<table border=0 bgcolor=000072 width=100% >
  <tr >
    <td nowrap >
      <center>
      <img src='http://dbamon.com/images/dbamonlogo.jpg' >
      </center>
<!-- ******** head_top - End ******** -->

<tr bgcolor=wheat><td><center><font size=4>Critical Event Notification for DB Instance: $instance 
  </center>
<!-- ******** head_bot - Start ******** -->
</table> </center> </b>
<p>
<font face='Trebuchet MS' size=2>
<b>&nbsp; This is an informational message to inform you that DBCC is now working on this incident
<br>which was detected by DBAmon: </b>
<p>

<table bgcolor=wheat border=0>
<tr><td><font color=darkred size=2><b>$text</font></b>
</table>

<p>&nbsp; You are receiving this message because you are listed in STAR as a DB contact for this DB 
<br>instance. The STAR contacts for this DB instance are:
<br><b>$email_recip</b>

<p>&nbsp; We are working on this problem, so we may contact you further if required. 

<p>Regards,
<br><img src='http://welcome.hp-ww.com/img/hpweb_1-2_topnav_hp_logo.gif' zwidth=50> 
HP DBCC 
</font>
  "; 

  #---- Send report
  open(RPT,">$tmpemail") || &error("Cannot open output $tmpemail");
  print RPT "$emailhdr";
  print RPT "$emailout";
  close(RPT);

  #print "<pre><font size=2>"; 
  #system("ll $tmpemail");
  #print "</pre>"; 

  system("cat $tmpemail | sendmail -v $email_recip 2>&1");

  #print "<pre>"; 
  #system("cat $tmpemail");
  #print "</pre>"; 

  system("rm $tmpemail");

  #---- Log this 
  $permlog = "/opt/dbamon/log/dbamon_helper.log"; 
  &msg("Logging this transaction to $permlog"); 

  ##system("echo '$date $instance $email_recip' >> $permlog 2>&1"); 

  open(LOG,">>$permlog") || &error("Cannot open output $permlog");
  print LOG "$date $instance $email_recip ($ENV{'REMOTE_HOST'})";
  close(LOG);
}

#-----------------------------------------------------------------------------
sub selectData
#-----------------------------------------------------------------------------
{
  &getCMDBInfo;

  $s_time = time;
  # Create the SQL SELECT statement
  if ($dbamon_repos eq "O") 
  {
    $sql  = "
      select 
	--to_char(ts,'YYYY/MM/DD-HH24:MI:SS'), 
	dbamon.dateconvert_19(ts), 
	instance, 
	text
      from 
	dbamon.events 
      where 
	instance = '$instance' 
	and ts >= sysdate - $days
	and sev = 'C'
	and (ticket is null or ticket != 'N')
      order by ts desc
    ";
  }
  else
  {
    $sql  = "
      select 
	--to_char(ts,'YYYY/MM/DD-HH24:MI:SS'), 
	dbamon.dateconvert_19(ts), 
	instance, 
	text
      from 
	dbamon.events 
      where 
	instance = '$instance' 
	--and ts >= sysdate - $days
	and datediff(day,ts,getdate()) <= $days
	and sev = 'C'
	and (ticket is null or ticket != 'N')
      order by ts desc
    ";
  }

  ##print "SQL=$sql\n";

  &msg("Querying DBAMON.EVENTS data for this instance for the last $days days - WHERE Clause: instance = '$instance'");

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed = $e_time - $s_time;

  &msg("Query elapsed time: $elapsed seconds");

  print "<p><font size=2><b>STAR Contacts For This DB Instance:\n"; 
  print "<br><font size=2><font color=blue>$email_recip</font></b>\n"; 

  print "<p><font size=2><b>Available Actions:</b>\n"; 
  print "<br><font size=2><font color=blue><li><b>Perform-Action-1:</b></font> <b>Send Incident Notification EMail and Inhibit Instance for 4 Hours</b>\n"; 

  print "<p><font size=4>Critical Events For Instance $instance During the Last $days Days Which Resulted in a Ticket</font>"; 

  print "<p><table border=3 width=80% >\n";
  print "<tr bgcolor=slate>
    <th><h5>Actions Available<br>For This Event 
    <th><h5>Event<br> Timestamp
    <th><h5>Event<br> Text
  \n";

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++; 
    
    $ts    = $Data[0];
    #$in    = $Data[1];
    $text  = $Data[2];
    #$ticket= $Data[3];

    $color = "pink";

    # <b>Send Notification Email To all STAR DB Contacts and<br>&nbsp;Inhibit This Instance For 4 Hours</b></a>"; 
    $urls = "
      <a href='http://$http_host/cgi-bin/dbamon_helper.pl?$prodtest,$instance,$in_hostname,$in_domain,$in_instance,$ts'>
      <b>Perform-Action-1</b></a>"; 
    ##<a href='http://$fqhostname/cgi-bin/dbamon_helper.pl?$prodtest,$instance,$in_hostname,$in_domain,$in_instance,$ts'>

    print "<tr bgcolor=$color>
      <td nowrap>$fs $urls
      <td nowrap>$fs $ts
      <td nowrap><b>$fs $text
    ";
  }

  if ($selectcount == 0) 
  { 
    print "<tr bgcolor=white><td colspan=5><b><font size=2>No event history data found for instance: $instance</b>\n";
  }
  print "</table>\n";
  &msg("Rows Selected: $selectcount");
}

#-----------------------------------------------------------------------------
sub IntHandler
#-----------------------------------------------------------------------------
{
   local($Signal) = @_;
   print "Signal=$Signal\n";
   exit(0);
}

#-----------------------------------------------------------------------------
#
# Main
#
#-----------------------------------------------------------------------------

$logfile = "/tmp/dbamon_hist.log";
unlink($logfile);
chop($CurrentDate = `date`);

&get_request;

@words = split(/,/,$ARGV[0]);
$prodtest    = $words[0];
$instance    = $words[1];
$in_hostname = $words[2];
$in_domain   = $words[3];
$in_instance = $words[4];
$event_ts    = $words[5];

if ($prodtest eq "test")
{
  $db = "dbamon_test";
}
else
{
  $db = "dbamon";
}

open(LOG, ">>$logfile" );
print LOG "$CurrentDate - $P dbms=$dbms prodtest=$prodtest\n";

print "Content-type: text/html\n\n
  <title>DBAmon Helper</title>
  <body bgcolor=white link=darkblue vlink=darkblue><font face=$font>
  <table width=750><tr><td><img src='/dbamon/img/dbamonlogo.jpg' width=750>
  <tr bgcolor=wheat><td><font face=$font size=5>
      <center>Helper - Instance: $instance</center>
  </table>";

$links_include = `cat /opt/dbamon/lib/trans_links.txt`;
print "
</table>
<table width=750>

 $links_include

</table><hr>
";

&msg("Starting - prodtest=$prodtest instance=$instance in_hostname=$in_hostname in_domain=$in_domain in_instance=$in_instance event_ts=$event_ts"); 

#---- Connect to DB
&connectDB;

if ($event_ts)
{
  #---- Process selection
  &msg("Processing selection - instance=$instance event_ts=$event_ts"); 
  &processSelection; 
  $goback = "-2"; 
}
else
{
  #---- Create initial menu
  &selectData;
  $goback = "-1"; 
}

##system("echo '$text' | mailx -s 'monitor--$P ($ENV{'REMOTE_HOST'}) event_ts=$event_ts' border\@dba.it.thecompany.com");
&msg("Done");

print "<p>
<script language='JavaScript'> function back() { history.go($goback); } </script>
<font size=2><b><a href='javascript:back()'>Click Here</a> to return to the previous page.</b></font>
<p>";

close(LOG);
exit 0;
