#-----------------------------------------------------------------------------
sub eventDupCheckDB
#-----------------------------------------------------------------------------
{
  my $edc_msg_in = $_[0];  

  my $zdate   = ""; 
  my $zoutlog = ""; 
  my $zoutlogfile = "/opt/dbamon/log/edc.log"; 

  my $edc_max_iter_seq = -1; 
  my $edc_max_ts_num   = -1;
  my $edc_max_ts_date  = ""; 
  my $edc_hours_ago    = -1; 

  my $edc_found        = 0; 
  my $edc_iters_ago    = -1; 
  my $sql              = ""; 

  $zdate = &getdate; 
  $zoutlog = "---------------------------------------------------\n";
  $zoutlog .= "$zdate | $modeout | eventDUpCheckDB: Starting\n";
  $zoutlog .= "$zdate | $modeout |   edc_msg_in=$edc_msg_in\n";

  $sql  = "select        
    max(te_iter_seq) as max_iter_seq,
    max(te_ts_num) as max_ts_num, 
    max(te_ts) as  max_ts_date,
    datediff(hh,max(te_ts), getdate()) as event_hours_ago
  from 
    dbamon.dbamon.task_event_cache 
  where 
    te_dbamonmode = '$modeout'
    and te_event_text = ?
  ";

  $sth = $dbh->prepare($sql) || &error_msg('Select_S18');
  $sth->bind_param(1, $edc_msg_in);
  $sth->execute || &error_msg('Execute_S18');

  while (@Data = $sth->fetchrow_array)
  {
    $edc_max_iter_seq = $Data[0];
    $edc_max_ts_num   = $Data[1];
    $edc_max_ts_date  = $Data[2];
    $edc_hours_ago    = $Data[3];
  }

  $zdate = &getdate; 
  $edc_iters_ago =  $g_thisiter_seq - $edc_max_iter_seq; 

  ##$edc_hours_ago = -2 if $edc_hours_ago eq ""; 
  if ($edc_hours_ago eq "")
  {
    $edc_hours_ago = -2; 
  }
  else
  {
    $edc_found = 1;    #---- hours is non-NULL so we did find something
  }

  $zoutlog .= "$zdate | $modeout |     edc_max_iter_seq=$edc_max_iter_seq\n";
  $zoutlog .= "$zdate | $modeout |     edc_max_ts_num=$edc_max_ts_num\n";
  $zoutlog .= "$zdate | $modeout |     edc_max_ts_date=$edc_max_ts_date\n";
  $zoutlog .= "$zdate | $modeout |       edc_found=$edc_found\n";
  $zoutlog .= "$zdate | $modeout |       edc_iters_ago=$edc_iters_ago\n";
  $zoutlog .= "$zdate | $modeout |       edc_hours_ago=$edc_hours_ago\n";

  $zoutlog .= "---------------------------------------------------\n";

  open(ZO, ">>$zoutlogfile") || &error("Unable to open output zoutlogfile=$zoutlogfile"); 
  print ZO $zoutlog; 
  close(ZO); 

  return ($edc_found, $edc_iters_ago, $edc_hours_ago); 
}

1;
