# -----------------------------------------------------------------------------
sub exportVars
# -----------------------------------------------------------------------------
{
  #---- Create a require file of parms for this instance
  my $zdate = &getdate;
  open(TMPFL6, ">$tmpfl6") || &error_msg("Can't open output $tmpfl6 - $!");
  print TMPFL6 "#---- START Require file for $titleraw[$thishost] - Created $zdate\n"; 
  print TMPFL6 "\$rq_listener_check     = '$listener_check[$thishost]';\n";
  print TMPFL6 "\$rq_runmon             = '$runmon[$thishost]';\n";
  print TMPFL6 "\$rq_backup_age         = '$backup_age[$thishost]';\n";
  print TMPFL6 "\$rq_prevent_db_restart = '$prevent_db_restart[$thishost]';\n";
  print TMPFL6 "\$rq_fs_check_mask      = '$fs_check_mask[$thishost]';\n";
  print TMPFL6 "\$rq_id1                = '$id1[$thishost]';\n";
  print TMPFL6 "\$rq_id2                = '$id2[$thishost]';\n";
  print TMPFL6 "\$rq_id3                = '$id3[$thishost]';\n";
  print TMPFL6 "\$rq_dbamonmode         = '$modeout';\n";

  #---- Oracle specific
  print TMPFL6 "\$rq_t_listlog          = '50';\n";

  #---- process t_arc_dest parms
  if ($arclog_by_dest[$thishost])
  {
    print TMPFL6 "\$rq_arclog_by_dest     = $arclog_by_dest[$thishost];\n";
    foreach $zkey (sort keys %t_arc_dest)
    {
      next unless $zkey == $thishost;
      for ($i = 1; $i <= 10; $i++)
      {
	if ($t_arc_dest{$thishost}{$i}{threshold_w})
	{
	  &logit("DEBUG exportVars - dest=$i threshold_w=$t_arc_dest{$thishost}{$i}{threshold_w}",$thishost);
	  print TMPFL6 "\$rq_arc_dest{$i}{threshold_w} = \"$t_arc_dest{$thishost}{$i}{threshold_w}\";\n";
	}
	if ($t_arc_dest{$thishost}{$i}{threshold_c})
	{
	  &logit("DEBUG exportVars - dest=$i threshold_c=$t_arc_dest{$thishost}{$i}{threshold_c}",$thishost);
	  print TMPFL6 "\$rq_arc_dest{$i}{threshold_c} = \"$t_arc_dest{$thishost}{$i}{threshold_c}\";\n";
	}
	if ($t_arc_dest{$thishost}{$i}{cmd})
	{
	  &logit("DEBUG exportVars - dest=$i cmd=$t_arc_dest{$thishost}{$i}{cmd}",$thishost);
	  print TMPFL6 "\$rq_arc_dest{$i}{cmd}         = \"$t_arc_dest{$thishost}{$i}{cmd}\";\n";
	}
      }
    }
  }

  #---- Check datafiles
  if ($check_datafiles[$thishost])
  {
    print TMPFL6 "\$rq_check_datafiles = \"$check_datafiles[$thishost]\";\n";
  }

  #---- Return to caller (DownloadSW.pl)
  print TMPFL6 "#---- END   Require file for $titleraw[$thishost]\n"; 
  print TMPFL6 "1;\n"; 
  close(TMPFL6);

  #---- TEST
  ##print "#1 t_arclog_w[$thishost]=$t_arclog_w[$thishost]\n"; 
  ##system("cat $tmpfl6"); 
  ##exit;

  $rcp_attempt = 0;
  for (0 .. $remsh_retries)
  {
    $rcp_attempt++; 
    #---- Send the file to the server
    &logit("exportVars() - Sending ($rcpcmd_save[$thishost]) probe require file dbamon_common_req_$instance[$thishost] - rcp_attempt=$rcp_attempt",$thishost);
    ##system("echo ' | dbamon_mailer -s 'DBAmon $titleraw[$thishost] instance IS NULL' $debug_email") if $instance[$thishost] eq "" && $company eq "thecompany";
    if (system("$rcpcmd_save[$thishost] $tmpfl6 $userid[$thishost]\@$hostname[$thishost]:$probe_dir[$thishost]/dbamon_common_req_$instance[$thishost].pl 2>$tmpfl2") != 0)
    {
      &logit("Error downloading $tmpfl6 to REQ file - rcp_attempt=$rcp_attempt remsh_retries=$remsh_retries - sleeping 30",$thishost);
      sleep 30;
      system("echo `date` >> $tmpfl2"); 
      ##system("cat $tmpfl2 | dbamon_mailer -s 'DBAmon $titleraw[$thishost] Download Req Error - rcp_attempt=$rcp_attempt' $debug_email") if $company eq "thecompany";
      &downloadFlagOff($thishost);
    }
    else
    {
      last;
    }
  }

  return;
}     

# -----------------------------------------------------------------------------
1;
