# -----------------------------------------------------------------------------
# Changes
#   21Aug07 BB - New
# -----------------------------------------------------------------------------
sub oraDGFull
# -----------------------------------------------------------------------------
{
  ($thishost) = @_;
  #
  # Get Instance online data
  #

  $total_size = 0;
  $total_free = 0;
  $total_used = 0;
  $total_chks = 0;
  $total_need = 0;

  system("rm -fr $tmpfl3");

  if ($ts_command[$thishost] ne "")
  {
    # invoke with ts_full {Twarn} {Tcrit} {Tfree}
    $parm = "$probe[$thishost] ts_full $t_diskwarn[$thishost] $t_diskcrit[$thishost] $t_freespace[$thishost] \"$ts_command[$thishost]\"";
  }
  else
  {
    # invoke with ts_full {Twarn} {Tcrit} {Tfree}
    $parm = "$probe[$thishost] ts_full $t_diskwarn[$thishost] $t_diskcrit[$thishost] $t_freespace[$thishost]";
  }

  ##print "parm=$parm \n";
  &remsh($parm,$tmpfl3,$thishost);
  system("cp $tmpfl3 /tmp/DBAmon_oraDGFull.txt");  #---- Debug

  #See if auto-inhibit occured
  if ($up[$thishost] eq "I")
  {
    logit("(Auto-Inhibited)",$thishost);
    return;
  }

  &logDetails($thishost,"<h3>Oracle ASM Diskgroups</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=antiquewhite>");
  &logDetails($thishost,"<tr bgcolor=slate>$f_s
    <th>$f_s Diskgroups
    <th>$f_s Size (gB)
    <th>$f_s Used (gB)
    <th>$f_s Free (gB)
    <th>$f_s Percent Full
    <th>$f_s Status:<br>W=Warning<br>C=Critical</tr>
  ");

  $tsokflag = 1;
  $fstotalsize = 0;

  open(TMPFL3, "$tmpfl3") || &error_msg("Can't open input $tmpfl3 - $!");
  while (<TMPFL3>)
  {
    &parse;

    if ($F1 eq "DG:") 
    {
      $ts    = $F2 ;
      $size  = $F3 ;
      $free  = $F4 ;
      $used  = $F5 ;
      $pct   = $F6 ;
      $status= $F7 ;

      $total_size += $size;
      $total_used += $used;

      if    ($status eq "C") { $color = "pink"; }
      elsif ($status eq "W") { $color = "yellow"; }
      else                   { $color = "lime"; }

      logDetails($thishost,"<tr bgcolor=$color>
        <td><b>$f_s $ts
        <td align=right><b>$f_s $size
        <td align=right><b>$f_s $used
        <td align=right><b>$f_s $free
        <td align=right><b>$f_s $pct
        <td><b>$f_s $status
        ");

      if ($status ne "OK" && $runmon[$thishost] ne "B") 
      {
        if ($status eq "C") 
        {
          &event("C",$thishost,"Oracle ASM Diskgroups: $ts - ${pct}% Full - Critical ($mbfree MB Free - Threshold: ${t_diskcrit[$thishost]}%)","DG-Full","DBA621C",$tmpfl3);
          $tsokflag = 0;   
        }
        elsif ($status eq "W") 
        {
          &event("W",$thishost,"Oracle ASM Diskgroups: $ts - ${pct}% Full - Warning ($mbfree MB Free - Threshold: ${t_diskwarn[$thishost]}%)","DG-Full","DBA622W",$tmpfl3);
          $tsokflag = 0;   
        }
      }
    }
  }
  close(TMPFL3);

  if ($total_size == 0)
  {
    &event("W",$thishost,"Oracle Error encountered while checking tablespaces","DGErr","DBA625W",$tmpfl3);
    &downloadFlagOff($thishost);
    return 1;
  }

  &logDetails($thishost,"
    <tr bgcolor=slate>$f_s
      <td>$f_s <b>Totals:</b>
      <td align=right><b>$f_s $total_size
      <td align=right><b>$f_s $total_used
      <td align=right><b>$f_s $total_free
      <td>
      <td>
  ");
  &logDetails($thishost,"</table><hr>");

  $system_size[$thishost] = $total_size;
  $system_used[$thishost] = $total_used;

  #
  # Write temp dbspace hist file to this dates file
  #

  if ($tsokflag)
  {
    logit("OK",$thishost);
  }
}
# -----------------------------------------------------------------------------
1;
